﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="RadComboBox.Net2" Namespace="Telerik.WebControls" TagPrefix="rad" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <script type="text/javascript">
        var supressDropDownClosing = false;
        
        function OnClientDropDownClosing(combobox)
        {
            return ( ! supressDropDownClosing);
        }
        
        function OnClientSelectedIndexChanging(combobox)
        {
            return ( ! supressDropDownClosing);
        }
        
        function OnClientDropDownOpening(combobox)
        {
            supressDropDownClosing = true;
        }
        
        function OnClientBlur(combobox)
        {
            supressDropDownClosing = false;
            
            combobox.ToggleDropDown();
        }
            
        function checkboxClick()
        {            
            collectSelectedItems();
        }
        
        function getItemCheckBox(item)
        {
            //Get the 'div' representing the current RadComboBox Item.
            var itemDiv = document.getElementById(item.ClientID);
            
            //Get the collection of all 'input' elements in the 'div' (which are contained in the Item).
            var inputs = itemDiv.getElementsByTagName("input");
            
            for (var inputIndex = 0; inputIndex < inputs.length; inputIndex++)
            {   
                var input = inputs[inputIndex];
                
                //Check the type of the current 'input' element.
                if (input.type == "checkbox")
                {
                    return input;
                }
            }
            
            return null;
        }
        
        function collectSelectedItems()
        {
            var combo = <%= RadComboBox1.ClientID %>;

            var items = combo.Items;
            
            var selectedItemsTexts = "";
            var selectedItemsValues = "";
            
            var itemsCount = items.length;
            
            for (var itemIndex = 0; itemIndex < itemsCount; itemIndex++)
            {
                var item = items[itemIndex];
               
                var checkbox = getItemCheckBox(item);
                
                //Check whether the Item's CheckBox) is checked.
                if (checkbox.checked)
                {
                    selectedItemsTexts += item.Text + ", ";
                    selectedItemsValues += item.Value + ", ";
                }
            }

            selectedItemsTexts = selectedItemsTexts.substring(0, selectedItemsTexts.length - 2);
            selectedItemsValues = selectedItemsValues.substring(0, selectedItemsValues.length - 2);
            
            //Set the text of the RadComboBox with the texts of the selected Items, separated by ','.
            combo.SetText(selectedItemsTexts);

            //Set the comboValue hidden field value with values of the selected Items, separated by ','.
            document.getElementById("comboValue").value = selectedItemsValues;
            
            //Clear the selection that RadComboBox has made internally.
            if (selectedItemsValues == "")
            {
                combo.ClearSelection();
            }
        }
        
        window.onload = collectSelectedItems;
    </script>
    <form id="form1" runat="server">
    <div>
        <input type="hidden" id="comboValue" value="" runat="server" />
        <rad:RadComboBox 
            runat="server" 
            ID="RadComboBox1" 
            AllowCustomText="true"
            HighlightTemplatedItems="true"
            OnClientDropDownOpening="OnClientDropDownOpening"
            OnClientDropDownClosing="OnClientDropDownClosing"
            OnClientSelectedIndexChanging="OnClientSelectedIndexChanging"
            OnClientBlur="OnClientBlur">
            <Items>
               <rad:RadComboBoxItem Text="One" Value="One" />
               <rad:RadComboBoxItem Text="Two" Value="Two" />
               <rad:RadComboBoxItem Text="Three" Value="Three" />
            </Items>
            <ItemTemplate>
               <asp:CheckBox runat="server" ID="CheckBox" onclick="checkboxClick();"  Text='<%# DataBinder.Eval(Container, "Text") %>' />
            </ItemTemplate>
         </rad:RadComboBox>
         <br />
         <asp:Button ID="Button1" runat="server" Text="Check Text and Value" OnClick="OnButton1_Click" />
         <br />
         RadComboBox1 Text: <asp:Label ID="Label1" runat="server"></asp:Label>
         <br />
         RadComboBox1 Value: <asp:Label ID="Label2" runat="server"></asp:Label>
    </div>
    </form>
</body>
</html>